/* 
* ---------------------------------------------------------------------------- 
* "THE BEER-WARE LICENSE" (Revision 42): 
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote 
* this file. As long as you retain this notice you can do whatever you want 
* with this stuff. If we meet some day, and you think this stuff is worth it, 
* you can buy us a beer in return.
* ---------------------------------------------------------------------------- 
* 
*/

package dk.ruc.vbr;

import java.util.LinkedList;
import java.util.Iterator;

abstract public class AbstractCSGObject extends AbstractObject
{
	final protected AbstractObject leftObject;
	final protected AbstractObject rightObject;
	
	protected final int ENTRY = 0;
	protected final int EXIT = 1;
	
	public AbstractCSGObject( AbstractObject left, AbstractObject right, Scene _scene )
	{
		super( _scene );

		leftObject = left;
		rightObject = right;
	}
	
	public void setShader( AbstractShader shader )
	{
		leftObject.setShader( shader );
		rightObject.setShader( shader );
	}
	
	public Vector getSurfaceNormal( Vector intersection )
	{
		return null;
	}
	
	public float[] getUV( Vector intersection )
	{
		return null;
	}

	public void transform( Matrix m )
	{
		leftObject.transform( m );
		rightObject.transform( m );
	}
	
	public void translate( float dx, float dy, float dz )
	{
		transform( Matrix.translateMatrix( dx, dy, dz ) );
	}
	
	public void rotate( float dx, float dy, float dz )
	{
		transform( Matrix.rotateMatrix( dx, dy, dz ) );
	}
	
	public void invert()
	{
		leftObject.invert();
		rightObject.invert();
	}
}
