
/* 
* ---------------------------------------------------------------------------- 
* "THE BEER-WARE LICENSE" (Revision 42): 
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote 
* this file. As long as you retain this notice you can do whatever you want 
* with this stuff. If we meet some day, and you think this stuff is worth it, 
* you can buy us a beer in return.
* ---------------------------------------------------------------------------- 
* 
*/

package dk.ruc.vbr;

abstract public class AbstractCamera
{
	Matrix matrix = null;

	public AbstractCamera(Options options)
	{
		matrix = new Matrix();
	}

	// skal vre sync'et
	abstract public Ray[] getRaysForNextPixel();
	abstract public Ray[] getRaysForPixel(int i);
	abstract public int getNextPixelNumber();

	public void transform(Matrix m)
	{
		matrix.transform(m);
	}

	public void translate( float dx, float dy, float dz )
	{
		transform( Matrix.translateMatrix( dx, dy, dz ) );
	}
	
	public void rotate( float dx, float dy, float dz )
	{
		transform( Matrix.rotateMatrix( dx, dy, dz ) );
	}
}