package dk.ruc.vbr;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import com.catode.PngEncoder;

/**
 * @version 	1.0
 * @author
 */
public class DefaultOutput extends AbstractOutput
{

	ColorModel colorModel;
	MemoryImageSource memImageSrc;
	Image image;

	protected int outputWidth = -1;
	protected int outputHeight = -1;

	/**
	 * Constructor for vbrDefaultOutput.
	 * @param options
	 */
	public DefaultOutput(Options options)
	{
		super(options);
		outputWidth = options.getInt("width");
		outputHeight = options.getInt("height");
		bitmap = new int[outputWidth * outputHeight];
		colorModel = new DirectColorModel(32, 0x00FF0000, 0x000FF00, 0x000000FF, 0);

		// create MemoryImageSource
		memImageSrc =
			new MemoryImageSource(outputWidth, outputHeight, colorModel, bitmap, 0, outputWidth);
		memImageSrc.setAnimated(true);
		memImageSrc.setFullBufferUpdates(true);
		image = java.awt.Toolkit.getDefaultToolkit().createImage(memImageSrc);
		for (int i = 0; i < bitmap.length; i++)
		{
			bitmap[i] = 0x00000000;
		}

	}

	public void write(File file)
	{
		//super.write();
		//memImageSrc.newPixels();
		/*JFrame frame = new JFrame();
		frame.setSize(outputWidth,outputHeight);
		frame.getContentPane().add(new JLabel(new ImageIcon(image)));
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation(
			(screenSize.width - frame.getSize().width) / 2,
			(screenSize.height - frame.getSize().height) / 2);
		frame.setVisible(true);
		frame.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e) 
			{
				System.out.println("closed");
			//	System.exit(0);
			}
		});*/
		try
		{


				PngEncoder enc = new PngEncoder (image, true);
				byte[] bimg = enc.pngEncode (true);
				FileOutputStream f = new FileOutputStream (file);
				for(int ii=0; ii < bimg.length; ii++)
				{
				    f.write (bimg[ii]);
				}

		}
		catch (IOException e)
		{
		}

	}

	/**
	 * Gets the image.
	 * @return Returns a Image
	 */
	public Image getImage()
	{
		memImageSrc.newPixels();
		return image;
	}

	/**
	 * Sets the image.
	 * @param image The image to set
	 */
	public void setImage(Image image)
	{
		this.image = image;
	}

}