
/* 
* ---------------------------------------------------------------------------- 
* "THE BEER-WARE LICENSE" (Revision 42): 
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote 
* this file. As long as you retain this notice you can do whatever you want 
* with this stuff. If we meet some day, and you think this stuff is worth it, 
* you can buy us a beer in return.
* ---------------------------------------------------------------------------- 
* 
*/

package dk.ruc.vbr;

import java.awt.SystemColor;

public class Matrix {

    /**
    * part of the matrix
    */
    public float m00=1, m01=0, m02=0, x =0;
    public float m10=0, m11=1, m12=0, y = 0;
    public float m20=0, m21=0, m22=1, z = 0;
    public float m30=0, m31=0, m32=0, m33=1;
    /**
    * Contructs the default matrix
    * 1 0 0 0
    * 0 1 0 0
    * 0 0 1 0
    * 0 0 0 1
    */
    public Matrix()
    {
    }
    /**
    * Contructs the matrix from the three vectors
    */
    public Matrix(Vector forward, Vector right, Vector up)
    {
        m00=forward.x;
        m10=forward.y;
        m20=forward.z;
        m01=right.x;
        m11=right.y;
        m21=right.z;
        m02=up.x;
        m12=up.y;
        m22=up.z;
        
/* This isn't right!?
        m00=right.x;
        m10=right.y;
        m20=right.z;
        m01=up.x;
        m11=up.y;
        m21=up.z;
        m02=forward.x;
        m12=forward.y;
        m22=forward.z;*/
    }
    /**
    * Returns a matrix for shifting
    */
    public static Matrix translateMatrix(float dx, float dy, float dz)
    {
        Matrix m=new Matrix();
        m.x=dx;
        m.y=dy;
        m.z=dz;
        return m;
    }
    /**
    * Returns a matrix for scaling
    */
    public static Matrix scaleMatrix(float dx, float dy, float dz)
    {
        Matrix m=new Matrix();
        m.m00=dx;
        m.m11=dy;
        m.m22=dz;
        return m;
    }
    /**
    * Returns a matrix for scaling
    */
    public static Matrix scaleMatrix(float d)
    {
        return Matrix.scaleMatrix(d,d,d);
    }
    /**
    * Returns a matrix for rotation
    */
    public static Matrix rotateMatrix(float dx, float dy, float dz)
    {
        Matrix out=new Matrix();
        float SIN;
        float COS;

        if (dx!=0)
        {
            Matrix m =new Matrix();
            SIN=(float) Math.sin(dx);
            COS=(float) Math.cos(dx);
            /*if (SIN < 0.0005 && SIN > -0.0005)
            	SIN = 0;
            if (COS < 0.0005 && COS > -0.0005)
            	COS = 0;*/
            m.m11=COS;
            m.m12=SIN;
            m.m21=-SIN;
            m.m22=COS;
            out.transform(m);
        }
        if (dy!=0)
        {
            Matrix m =new Matrix();
            SIN=(float) Math.sin(dy);
            COS=(float) Math.cos(dy);
            /*if (SIN < 0.0005 && SIN > -0.0005)
            	SIN = 0;
            if (COS < 0.0005 && COS > -0.0005)
            	COS = 0;*/
            m.m00=COS;
            m.m02=SIN;
            m.m20=-SIN;
            m.m22=COS;
            out.transform(m);
        }
        if (dz!=0)
        {
            Matrix m =new Matrix();
            SIN=(float) Math.sin(dz);
            COS=(float) Math.cos(dz);
            /*if (SIN < 0.0005)
            	SIN = 0;
            if (COS < 0.0005)
            	COS = 0;*/
            m.m00=COS;
            m.m01=SIN;
            m.m10=-SIN;
            m.m11=COS;
            out.transform(m);
        }
        return out;
    }
    /**
    * translates this matrix
    */
    public void translate(float dx, float dy, float dz)
    {
        transform(translateMatrix(dx,dy,dz));
    }
    /**
    * scales this matrix
    */
    public void scale(float dx, float dy, float dz)
    {
        transform(scaleMatrix(dx,dy,dz));
    }
    /**
    * scales this matrix
    */
    public void scale(float d)
    {
        transform(scaleMatrix(d));
    }
    /**
    * rotates this matrix
    */
    public void rotate(float dx, float dy, float dz)
    {
        transform(rotateMatrix(dx,dy,dz));
    }
    /**
    * scales this matrix
    */
    public void scaleSelf(float dx, float dy, float dz)
    {
        preTransform(scaleMatrix(dx,dy,dz));
    }
    /**
    * scales this matrix
    */
    public void scaleSelf(float d)
    {
        preTransform(scaleMatrix(d));
    }
    /**
    * rotates this matrix
    */
    public void rotateSelf(float dx, float dy, float dz)
    {
        preTransform(rotateMatrix(dx,dy,dz));
    }
    /**
    * transforms the matrix by n from left (this=n x this)
    */
    public void transform(Matrix n)
    {
        Matrix m = this.getClone();
        
        m00 = n.m00*m.m00 + n.m01*m.m10 + n.m02*m.m20;
        m01 = n.m00*m.m01 + n.m01*m.m11 + n.m02*m.m21;
        m02 = n.m00*m.m02 + n.m01*m.m12 + n.m02*m.m22;
        x = n.m00*m.x + n.m01*m.y + n.m02*m.z + n.x;
        m10 = n.m10*m.m00 + n.m11*m.m10 + n.m12*m.m20;
        m11 = n.m10*m.m01 + n.m11*m.m11 + n.m12*m.m21;
        m12 = n.m10*m.m02 + n.m11*m.m12 + n.m12*m.m22;
        y = n.m10*m.x + n.m11*m.y + n.m12*m.z + n.y;
        m20 = n.m20*m.m00 + n.m21*m.m10 + n.m22*m.m20;
        m21 = n.m20*m.m01 + n.m21*m.m11 + n.m22*m.m21;
        m22 = n.m20*m.m02 + n.m21*m.m12 + n.m22*m.m22;
        z = n.m20*m.x + n.m21*m.y + n.m22*m.z + n.z;
    }
    /**
    * transforms the matrix by n from right (this=this x n)
    */
    public void preTransform(Matrix n)
    {
        Matrix m=this.getClone();
        
        m00 = m.m00*n.m00 + m.m01*n.m10 + m.m02*n.m20;
        m01 = m.m00*n.m01 + m.m01*n.m11 + m.m02*n.m21;
        m02 = m.m00*n.m02 + m.m01*n.m12 + m.m02*n.m22;
        x = m.m00*n.x + m.m01*n.y + m.m02*n.z + m.x;
        m10 = m.m10*n.m00 + m.m11*n.m10 + m.m12*n.m20;
        m11 = m.m10*n.m01 + m.m11*n.m11 + m.m12*n.m21;
        m12 = m.m10*n.m02 + m.m11*n.m12 + m.m12*n.m22;
        y = m.m10*n.x + m.m11*n.y + m.m12*n.z + m.y;
        m20 = m.m20*n.m00 + m.m21*n.m10 + m.m22*n.m20;
        m21 = m.m20*n.m01 + m.m21*n.m11 + m.m22*n.m21;
        m22 = m.m20*n.m02 + m.m21*n.m12 + m.m22*n.m22;
        z = m.m20*n.x + m.m21*n.y + m.m22*n.z + m.z;
    }
    /**
    * returns m1 x m2 (static)
    */
    public static Matrix multiply(Matrix m1, Matrix m2)
    {
        Matrix m=new Matrix();
        
        m.m00 = m1.m00*m2.m00 + m1.m01*m2.m10 + m1.m02*m2.m20;
        m.m01 = m1.m00*m2.m01 + m1.m01*m2.m11 + m1.m02*m2.m21;
        m.m02 = m1.m00*m2.m02 + m1.m01*m2.m12 + m1.m02*m2.m22;
        m.x = m1.m00*m2.x + m1.m01*m2.y + m1.m02*m2.z + m1.x;
        m.m10 = m1.m10*m2.m00 + m1.m11*m2.m10 + m1.m12*m2.m20;
        m.m11 = m1.m10*m2.m01 + m1.m11*m2.m11 + m1.m12*m2.m21;
        m.m12 = m1.m10*m2.m02 + m1.m11*m2.m12 + m1.m12*m2.m22;
        m.y = m1.m10*m2.x + m1.m11*m2.y + m1.m12*m2.z + m1.y;
        m.m20 = m1.m20*m2.m00 + m1.m21*m2.m10 + m1.m22*m2.m20;
        m.m21 = m1.m20*m2.m01 + m1.m21*m2.m11 + m1.m22*m2.m21;
        m.m22 = m1.m20*m2.m02 + m1.m21*m2.m12 + m1.m22*m2.m22;
        m.z = m1.m20*m2.x + m1.m21*m2.y + m1.m22*m2.z + m1.z;
        return m;
    }
    /**
    * Returns the matrix as a string
    */
    public String toString()
    {
        StringBuffer out=new StringBuffer("<Matrix: \r\n");
        out.append(m00+","+m01+","+m02+","+x+",\r\n");
        out.append(m10+","+m11+","+m12+","+y+",\r\n");
        out.append(m20+","+m21+","+m22+","+z+",\r\n");
        out.append(m30+","+m31+","+m32+","+m33+">\r\n");
        return out.toString();
    }
    /**
    * Returns a clone of the matrix
    */
    public Matrix getClone()
    {
        Matrix m=new Matrix();
        m.m00=m00;  m.m01=m01;  m.m02=m02;  m.x=x;
        m.m10=m10;  m.m11=m11;  m.m12=m12;  m.y=y;
        m.m20=m20;  m.m21=m21;  m.m22=m22;  m.z=z;
        m.m30=m30;  m.m31=m31;  m.m32=m32;  m.m33=m33;
        return m;
    }
    /**
    * Returns the inverse of this matrix
    */
    public Matrix inverse()
    {
        Matrix m=new Matrix();
        float q1 = m12;  float q6 = m10*m01;  float q7 = m10*m21;  float q8 = m02;
        float q13 = m20*m01;  float q14 = m20*m11;  float q21 = m02*m21;  float q22 = x*m21;
        float q25 = m01*m12;  float q26 = m01*y;  float q27 = m02*m11;  float q28 = x*m11;
        float q29 = m10*m22;  float q30 = m10*z;  float q31 = m20*m12;  float q32 = m20*y;
        float q35 = m00*m22;  float q36 = m00*z;  float q37 = m20*m02;  float q38 = m20*x;
        float q41 = m00*m12;  float q42 = m00*y;  float q43 = m10*m02;  float q44 = m10*x;
        float q45 = m00*m11;  float q48 = m00*m21;
        float q49 = q45*m22-q48*q1-q6*m22+q7*q8;
        float q50 = q13*q1-q14*q8;
        float q51 = 1;
        if(q49!=0 || q50!=0)
        {
            q51 = 1/(q49+q50);
        }
        m.m00 = (m11*m22*m33-m11*z*m32-m21*m12*m33+m21*y*m32+m31*m12*z-m31*y*m22)*q51;
        m.m01 = -(m01*m22*m33-m01*z*m32-q21*m33+q22*m32)*q51;
        m.m02 = (q25*m33-q26*m32-q27*m33+q28*m32)*q51;
        m.x = -(q25*z-q26*m22-q27*z+q28*m22+q21*y-q22*m12)*q51;
        m.m10 = -(q29*m33-q30*m32-q31*m33+q32*m32)*q51;
        m.m11 = (q35*m33-q36*m32-q37*m33+q38*m32)*q51;
        m.m12 = -(q41*m33-q42*m32-q43*m33+q44*m32)*q51;
        m.y = (q41*z-q42*m22-q43*z+q44*m22+q37*y-q38*m12)*q51;
        m.m20 = (q7*m33-q30*m31-q14*m33+q32*m31)*q51;
        m.m21 = -(q48*m33-q36*m31-q13*m33+q38*m31)*q51;
        m.m22 = (q45*m33-q42*m31-q6*m33+q44*m31)*q51;
        m.z = -(q45*z-q42*m21-q6*z+q44*m21+q13*y-q38*m11)*q51;
        return m;
    }
    /**
    * Resets the matrix
    */
    public void reset()
    {
        m00=1; m01=0; m02=0; x=0;
        m10=0; m11=1; m12=0; y=0;
        m20=0; m21=0; m22=1; z=0;
        m30=0; m31=0; m32=0; m33=1;
    }
    
	/**
	* Transform the given vector
	*/
	public Vector transform( Vector vector )
	{
		float x = vector.x * m00 + vector.y * m01 + vector.z * m02 + this.x;
		float y = vector.x * m10 + vector.y * m11 + vector.z * m12 + this.y;
		float z = vector.x * m20 + vector.y * m21 + vector.z * m22 + this.z;
		return new Vector(x,y,z);
	}
	
	public Vector getForward()
	{
		return new Vector( m00, m10, m20 );
	}
	
	public Vector getRight()
	{
		return new Vector( m01, m11, m21 );
	}
	
	public Vector getUp()
	{
		return new Vector( m02, m12, m22 );
	}
	
	public Vector getOrigin()
	{
		return new Vector( x,y,z );
	}
	
	public static void main( String args[] )
	{
		Matrix matrix = new Matrix();
		
		matrix.rotate( 0, (float)(Math.PI * 0.5), 0 ); 
		
		Vector forward = new Vector(1,0,0);
		System.out.println(matrix);
		System.out.println( "Vector before transform: " + forward );
		
		forward = matrix.transform( forward );
		
		System.out.println( "Vector after transform: " + forward + "\n(should be (0,0,1)" );
	}
}

