
/* 
* ---------------------------------------------------------------------------- 
* "THE BEER-WARE LICENSE" (Revision 42): 
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote 
* this file. As long as you retain this notice you can do whatever you want 
* with this stuff. If we meet some day, and you think this stuff is worth it, 
* you can buy us a beer in return.
* ---------------------------------------------------------------------------- 
* 
*/

package dk.ruc.vbr;

// rekursiv ftter
                                                     
public class Render
{

	static int numberOfTraces = 0;

	public static Color trace(Scene scene, Ray ray)
	{
		numberOfTraces++;
		// find some appropriate number
		if ( ray.importance < 0.001 )
		{
			return scene.ambientColor;
		}
		
		AbstractObject[] obj = scene.getObjects();
		
		float t = Float.MAX_VALUE;
//		float temp;
		AbstractObject nearestObj = null;
		Intersection nearestIntersection = null;
		Intersection temp = null;
		
		for (int i = 0; i < obj.length; i++)
		{
			temp = obj[i].getNearestIntersection( ray );
			
			if ( temp.t < t )
			{
				nearestObj = temp.object;
				t = temp.t;
			}
		}
		if (nearestObj != null)
		{
			Color color;
            color = nearestObj.getShader().getIntersectionColor(ray, t);
            color = color.attenuate(t);
            return color;
		} 
		return scene.ambientColor;
	}

	
	/**
	 * Gets the numberOfTraces.
	 * @return Returns a int
	 */
	protected static int getNumberOfTraces()
	{
		return numberOfTraces;
	}

}
