/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote
* this file. As long as you retain this notice you can do whatever you want
* with this stuff. If we meet some day, and you think this stuff is worth it,
* you can buy us a beer in return.
* ----------------------------------------------------------------------------
*
*/

package dk.ruc.vbr.gui;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.io.File;
import dk.ruc.vbr.*;

public class Raytracer extends JFrame
{

	private File sceneFile;
	private File outputFile;

	private JButton renderButton = new JButton("Render");
	private JButton chooseSceneButton = new JButton("Choose");
	private JButton chooseOutputButton = new JButton("Choose");
	private JTextField sceneTextField = new JTextField();
	private JTextField outputTextField = new JTextField();
	private JLabel sceneLabel = new JLabel("Scene file");
	private JLabel outputLabel = new JLabel("Output file");
	private JLabel outputWidthLabel = new JLabel("Output width");
	private JLabel outputHeightLabel = new JLabel("Output height");
	private JTextField outputWidthField = new JTextField("400");
	private JTextField outputHeightField = new JTextField("300");
	/*
	private JMenuBar menuBar = new JMenuBar();
	private JMenu formatMenu = new JMenu("Image Format");
	private JRadioButtonMenuItem tiffItem = new JRadioButtonMenuItem("Tiff");
	private JRadioButtonMenuItem tgaItem = new JRadioButtonMenuItem("Targa");
	private JRadioButtonMenuItem pngItem = new JRadioButtonMenuItem("PNG");
	private JRadioButtonMenuItem jpgItem = new JRadioButtonMenuItem("JPEG");
	private JRadioButtonMenuItem gifItem = new JRadioButtonMenuItem("GIF");
	private JRadioButtonMenuItem bmpItem = new JRadioButtonMenuItem("BMP");
	
	private ButtonGroup formatGroup = new ButtonGroup();
	*/
	private String currentExtension;

	public Raytracer(String ui)
	{
		if (ui != null)
			setUI(ui);

javax.swing.UIManager.LookAndFeelInfo[] ting = UIManager.getInstalledLookAndFeels();
		for (int i = 0; i < ting.length; i++)
		{
				System.err.println(ting[i]);
		}
	
		/*
				tiffItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(TIFF);
					}
				});
				tgaItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(TGA);
					}
				});
				pngItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(PNG);
					}
				});
				jpgItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(JPG);
					}
				});
				gifItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(GIF);
					}
				});
				bmpItem.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						setFormat(BMP);
					}
				});
				menuBar.add(formatMenu);
				formatMenu.add(tiffItem);
				formatMenu.add(tgaItem);
				formatMenu.add(pngItem);
				formatMenu.add(jpgItem);		
				formatMenu.add(gifItem);
				formatMenu.add(bmpItem);
				
				formatGroup.add(tiffItem);
				formatGroup.add(tgaItem);
				formatGroup.add(pngItem);
				formatGroup.add(jpgItem);		
				formatGroup.add(gifItem);
				formatGroup.add(bmpItem);
				
				
				jpgItem.setSelected(true);
				*/
		GriddedPanel panel = new GriddedPanel();
		getContentPane().add(BorderLayout.CENTER, panel);
		//getContentPane().add(BorderLayout.NORTH, menuBar);

		chooseSceneButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				chooseSceneFile();
			}
		});
		chooseOutputButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				chooseOutputFile();
			}
		});
		renderButton.addActionListener(new ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				render();
			}
		});
		sceneTextField.setPreferredSize(new Dimension(250, sceneTextField.getPreferredSize().height));
		outputTextField.setPreferredSize(new Dimension(250, sceneTextField.getPreferredSize().height));
		outputWidthField.setPreferredSize(
			new Dimension(250, outputWidthField.getPreferredSize().height));
		outputHeightField.setPreferredSize(
			new Dimension(250, outputHeightField.getPreferredSize().height));

		panel.addFilledComponent(outputWidthLabel, 1, 1);
		panel.addFilledComponent(outputWidthField, 1, 2, 2, 1, GridBagConstraints.HORIZONTAL);
		panel.addFilledComponent(outputHeightLabel, 2, 1);
		panel.addFilledComponent(outputHeightField, 2, 2, 2, 1, GridBagConstraints.HORIZONTAL);

		panel.addFilledComponent(sceneLabel, 3, 1);
		panel.addFilledComponent(sceneTextField, 3, 2, 3, 1, GridBagConstraints.HORIZONTAL);
		panel.addComponent(chooseSceneButton, 3, 5);

		panel.addFilledComponent(outputLabel, 4, 1);
		panel.addFilledComponent(outputTextField, 4, 2, 3, 1, GridBagConstraints.HORIZONTAL);
		panel.addFilledComponent(chooseOutputButton, 4, 5);

		panel.addFilledComponent(renderButton, 6, 5);

		this.setSize(400, 300);
		this.setTitle("Verdens Bedste Raytracer");
		this.setResizable(false);

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation(
			(screenSize.width - getSize().width) / 2,
			(screenSize.height - getSize().height) / 2);
		this.setVisible(true);

	}
	public void render()
	{
		Options options = new Options();
		options.put("width", outputWidthField.getText().trim());
		options.put("height", outputHeightField.getText().trim());
		options.put("aa","4");
		options.put("photonmap", "true");
		options.put("threads","1"); 
		Scene scene;
		try
		{
			scene = new SceneLoader(new java.io.File(sceneTextField.getText()), options).buildScene();
			//= new TextureSceneLoader().getScene(null);

			DefaultOutput output = new DefaultOutput(options);

			dk.ruc.vbr.Raytracer tracer = new dk.ruc.vbr.Raytracer(scene, output, options);

			RaytracerDisplay display = new RaytracerDisplay(tracer);
			//tracer.render();
			//Thread thread = new Thread(display);
			display.start();


		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

	}
	public void chooseSceneFile()
	{
		JFileChooser chooser = new JFileChooser();
		FileFilter filter = new FileFilter()
		{
			/**
			 * @see FileFilter#accept(File)
			 */
			public boolean accept(File file)
			{
				if (file.isDirectory())
					return true;
					
				if (file.getName().toLowerCase().endsWith("scd"))
				{
					return true;
				}
				else
					return false;
			}

			/**
			 * @see FileFilter#getDescription()
			 */
			public String getDescription()
			{
				return "*.scd";
			}

		};
		chooser.addChoosableFileFilter(filter);
		chooser.setMultiSelectionEnabled(false);

		if (chooser.showOpenDialog(this) != JFileChooser.APPROVE_OPTION)
		{
			return;
		}
		sceneFile = chooser.getSelectedFile();
		if (sceneFile != null)
			sceneTextField.setText(sceneFile.getPath());
	}
	public void chooseOutputFile()
	{
		JFileChooser chooser = new JFileChooser();

		chooser.setMultiSelectionEnabled(false);

		if (chooser.showSaveDialog(this) != JFileChooser.APPROVE_OPTION)
		{
			return;
		}
		outputFile = chooser.getSelectedFile();
		if (outputFile != null)
		{
			int index = outputFile.getPath().lastIndexOf(".");
			if (index < 0)
				outputTextField.setText(outputFile.getPath());
			else
				outputTextField.setText(outputFile.getPath().substring(0, index) + currentExtension);
		}
	}
	public void setFormat(String format)
	{
		currentExtension = format;
		int index = outputTextField.getText().lastIndexOf(".");
		if (index < 0)
			return;
		else
		{
			outputTextField.setText(outputTextField.getText().substring(0, index) + currentExtension);
		}
	}
	public void setUI(String ui)
	{
		try
		{
			UIManager.setLookAndFeel(ui);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	public static void main(String[] args)
	{
		if (args.length > 0)
			new Raytracer(args[0]);
		else
			new Raytracer(null);
	}
	protected void processWindowEvent(WindowEvent e)
	{

		if (e.getID() == WindowEvent.WINDOW_CLOSING)
		{
			System.exit(0);
		}
		else
		{
			super.processWindowEvent(e);
		}
	}

	private class GriddedPanel extends JPanel
	{
		private GridBagConstraints constraints;

		// default constraints value definitions
		private static final int C_HORZ = GridBagConstraints.HORIZONTAL;
		private static final int C_NONE = GridBagConstraints.NONE;
		private static final int C_WEST = GridBagConstraints.WEST;
		private static final int C_WIDTH = 1;
		private static final int C_HEIGHT = 1;

		// Create a GridBagLayout panel using a default insets constraint.
		public GriddedPanel()
		{
			this(new Insets(2, 2, 2, 2));
		}

		// Create a GridBagLayout panel using the specified insets
		// constraint.
		public GriddedPanel(Insets insets)
		{
			super(new GridBagLayout());
			constraints = new GridBagConstraints();
			constraints.anchor = GridBagConstraints.WEST;
			constraints.insets = insets;
		}

		// Add a component to specified row and col.
		public void addComponent(JComponent component, int row, int col)
		{
			addComponent(component, row, col, C_WIDTH, C_HEIGHT, C_WEST, C_NONE);
		}

		// Add component to specified row and col, spanning across
		// a specified number of columns and rows.
		public void addComponent(JComponent component, int row, int col, int width, int height)
		{
			addComponent(component, row, col, width, height, C_WEST, C_NONE);
		}

		// Add component to specified row and col, using a specified
		// anchor constraint
		public void addAnchoredComponent(JComponent component, int row, int col, int anchor)
		{
			addComponent(component, row, col, C_WIDTH, C_HEIGHT, anchor, C_NONE);
		}

		// Add component to specified row and col, spanning across
		// a specified number of columns and rows, using a specified
		// anchor constraint
		public void addAnchoredComponent(
			JComponent component,
			int row,
			int col,
			int width,
			int height,
			int anchor)
		{
			addComponent(component, row, col, width, height, anchor, C_NONE);
		}

		// Add component to specified row and col 
		// filling the column horizontally.
		public void addFilledComponent(JComponent component, int row, int col)
		{
			addComponent(component, row, col, C_WIDTH, C_HEIGHT, C_WEST, C_HORZ);
		}

		// Add component to the specified row and col 
		// with the specified fill constraint.
		public void addFilledComponent(JComponent component, int row, int col, int fill)
		{
			addComponent(component, row, col, C_WIDTH, C_HEIGHT, C_WEST, fill);
		}

		// Add component to the specified row and col,
		// spanning a specified number of columns and rows,
		// with specified fill constraint
		public void addFilledComponent(
			JComponent component,
			int row,
			int col,
			int width,
			int height,
			int fill)
		{
			addComponent(component, row, col, width, height, C_WEST, fill);
		}

		// Add component to the specified row and col,
		// spanning specified number of columns and rows, with
		// specified fill and anchor constraints
		public void addComponent(
			JComponent component,
			int row,
			int col,
			int width,
			int height,
			int anchor,
			int fill)
		{
			constraints.gridx = col;
			constraints.gridy = row;
			constraints.gridwidth = width;
			constraints.gridheight = height;
			constraints.anchor = anchor;
			double weightx = 0.0;
			double weighty = 0.0;

			// only use extra horizontal or vertical space if component
			// spans more than one column and/or row.
			if (width > 1)
				weightx = 1.0;
			if (height > 1)
				weighty = 1.0;

			switch (fill)
			{
				case GridBagConstraints.HORIZONTAL :
					constraints.weightx = weightx;
					constraints.weighty = 0.0;
					break;
				case GridBagConstraints.VERTICAL :
					constraints.weighty = weighty;
					constraints.weightx = 0.0;
					break;
				case GridBagConstraints.BOTH :
					constraints.weightx = weightx;
					constraints.weighty = weighty;
					break;
				case GridBagConstraints.NONE :
					constraints.weightx = 0.0;
					constraints.weighty = 0.0;
					break;
				default :
					break;
			}
			constraints.fill = fill;
			add(component, constraints);
		}
	}

}