/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote
* this file. As long as you retain this notice you can do whatever you want
* with this stuff. If we meet some day, and you think this stuff is worth it,
* you can buy us a beer in return.
* ----------------------------------------------------------------------------
*
*/

package dk.ruc.vbr.gui;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import java.awt.*;
import java.awt.event.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.*;

import com.catode.PngEncoder;


public class RaytracerDisplay extends Thread
{

	JDialog dialog = new JDialog();
	dk.ruc.vbr.Raytracer tracer;
	JProgressBar progressbar = new JProgressBar();
	JLabel imageLabel = new JLabel();
	JLabel timeLabelText = new JLabel("Time");
	JLabel timeLabel = new JLabel("-");
	JButton button = new JButton("Save Image");
	ImageIcon icon = new ImageIcon();

	public RaytracerDisplay(dk.ruc.vbr.Raytracer tracer)
	{
		this.tracer = tracer;
		button.setEnabled(false);

		java.awt.GridBagConstraints gridBagConstraints;

		dialog.getContentPane().setLayout(new java.awt.GridBagLayout());

		progressbar.setMaximum(tracer.getLength());
		icon.setImage(tracer.getOutput().getImage());
		imageLabel.setIcon(icon);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		gridBagConstraints.gridwidth = 3;
		dialog.getContentPane().add(imageLabel, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = 3;
		gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.CENTER;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		dialog.getContentPane().add(progressbar, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 10);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		dialog.getContentPane().add(timeLabelText, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
		dialog.getContentPane().add(timeLabel, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 2;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.insets = new java.awt.Insets(2, 5, 5, 5);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		dialog.getContentPane().add(button, gridBagConstraints);

		/*dialog.getContentPane().setLayout(new BorderLayout());
			dialog.getContentPane().add(progressbar, BorderLayout.SOUTH);
			*/

		/*		dialog.getContentPane().add(imageLabel, BorderLayout.CENTER);*/

		button.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				save();
			}
		});

		dialog.addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent e)
			{
				halt();
			}
		});
		dialog.pack();
		dialog.setResizable(false);
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		dialog.setLocation(
			(screenSize.width - dialog.getSize().width) / 2,
			(screenSize.height - dialog.getSize().height) / 2);

		dialog.setTitle("Rendering ...");

	}
	public void run()
	{
		dialog.setVisible(true);
		Runnable render = new Runnable()
		{
			public void run()
			{
				tracer.render();
			}
		};
		Thread renderThread = new Thread(render);
		renderThread.start();

		while (true)
		{
			progressbar.setValue(tracer.getIndex());
			icon.setImage(tracer.getOutput().getImage());
			imageLabel.setIcon(icon);

			if (tracer.getHalt() == true)
			{
				break;
			}
			try
			{
				this.sleep(1000);
			}
			catch (InterruptedException e)
			{
			}
		}
		timeLabel.setText(String.valueOf(tracer.getTime()) + " ms");
		button.setEnabled(true);
		dialog.setTitle("Rendering ... complete");
		//dialog.setVisible(false);

	}
	public void save()
	{
		// Add your handling code here:
		JFileChooser chooser = new JFileChooser();
		FileFilter filter = new FileFilter()
		{
			/**
			 * @see FileFilter#accept(File)
			 */
			public boolean accept(File file)
			{
				if (file.isDirectory())
					return true;

				if (file.getName().toLowerCase().endsWith("scd"))
				{
					return true;
				}
				else
					return false;
			}

			/**
			 * @see FileFilter#getDescription()
			 */
			public String getDescription()
			{
				return "*.png";
			}

		};
		chooser.addChoosableFileFilter(filter);
		chooser.setMultiSelectionEnabled(false);

		if (chooser.showSaveDialog(dialog) != JFileChooser.APPROVE_OPTION)
		{
			return;
		}

		try
		{
			PngEncoder enc = new PngEncoder(tracer.getOutput().getImage(), true);
			byte[] bimg = enc.pngEncode(true);
			FileOutputStream f = new FileOutputStream(chooser.getSelectedFile());
			for (int ii = 0; ii < bimg.length; ii++)
			{
				f.write(bimg[ii]);
			}
		}
		catch (FileNotFoundException e)
		{
		}
		catch (IOException e)
		{
		}

	}
	public void halt()
	{
		tracer.stop();
		stop();
		dialog.setVisible(false);
		dialog.dispose();
	}
}