/*
* ----------------------------------------------------------------------------
* "THE BEER-WARE LICENSE" (Revision 42):
* <doktor@dyregod.dk> <mads@danquah.dk> <hartlev@ruc.dk> <tnjr@ruc.dk> wrote
* this file. As long as you retain this notice you can do whatever you want
* with this stuff. If we meet some day, and you think this stuff is worth it,
* you can buy us a beer in return.
* ----------------------------------------------------------------------------
*
*/

package dk.ruc.vbr.gui;

import javax.swing.*;
import javax.swing.filechooser.FileFilter;
import java.awt.*;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;

import dk.ruc.vbr.*;

public class RaytracerGUI extends javax.swing.JFrame
{

	// Variables declaration - do not modify
	private JButton renderButton;
	private JComboBox photonsCombo;
	private JCheckBox aaCheckBox;
	private JPanel aaPanel;
	private JLabel heightLbl;
	private JComboBox aaPlotsCombo;
	private JComboBox aaRaysCombo;
	private JLabel widthLbl;
	private JPanel pMapPanel;
	private JSlider widthSlider;
	private JLabel radianceEstLbl;
	private JTextField sceneFileField;
	private JLabel widthSizeLbl;
	private JLabel aaRaysLbl;
	private JLabel aaPlotsLbl;
	private JLabel heightSizeLbl;
	private JLabel photonsLbl;
	private JComboBox radianceEstCombo;
	private JButton sceneChooserButton;
	private JPanel jPanel1;
	private JPanel scenePanel;
	private JSlider heightSlider;
	private JPanel outputPanel;
	private JCheckBox pmapCheckBox;
	private JSlider distanceSlider;
	private JLabel distLbl;
	private JLabel distSizeLbl;
	// End of variables declaration
	private File sceneFile;
	/** Creates new form GUI2 */
	public RaytracerGUI(String[] args)
	{
		if (args.length > 0)
		{
			try
			{
				UIManager.setLookAndFeel(args[0]);
			}
			catch (ClassNotFoundException e)
			{
			}
			catch (InstantiationException e)
			{
			}
			catch (IllegalAccessException e)
			{ 
			}
			catch (UnsupportedLookAndFeelException e)
			{
			}
		}
		initComponents();

		this.setResizable(false);

		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setLocation(
			(screenSize.width - getSize().width) / 2,
			(screenSize.height - getSize().height) / 2);

	}

	/** This method is called from within the constructor to
	 * initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is
	 * always regenerated by the Form Editor.
	 */
	private void initComponents()
	{
		GridBagConstraints gridBagConstraints;
		jPanel1 = new JPanel();
		aaPanel = new JPanel();
		aaCheckBox = new JCheckBox();
		aaPlotsCombo = new JComboBox();
		aaRaysLbl = new JLabel();
		pMapPanel = new JPanel();
		pmapCheckBox = new JCheckBox();
		radianceEstCombo = new JComboBox();
		photonsCombo = new JComboBox();
		radianceEstLbl = new JLabel();
		photonsLbl = new JLabel();
		outputPanel = new JPanel();
		widthLbl = new JLabel();
		widthSizeLbl = new JLabel();
		heightLbl = new JLabel();
		heightSizeLbl = new JLabel();
		widthSlider = new JSlider();
		heightSlider = new JSlider();
		distanceSlider = new JSlider();
		scenePanel = new JPanel();
		sceneFileField = new JTextField();
		sceneChooserButton = new JButton();
		renderButton = new JButton();
		aaPlotsLbl = new JLabel();
		aaRaysCombo = new JComboBox();
		distLbl = new JLabel();
		distSizeLbl = new JLabel();
		setTitle("Raytracer");
		setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		addWindowListener(new java.awt.event.WindowAdapter()
		{
			public void windowClosing(java.awt.event.WindowEvent evt)
			{
				exitForm(evt);
			}
		});
		jPanel1.setLayout(new java.awt.GridBagLayout());
		
		aaPanel.setLayout(new java.awt.GridBagLayout());
		aaPanel.setBorder(new javax.swing.border.TitledBorder("Anti Aliasing"));
		aaPanel.setToolTipText("Anti Aliasing Options");
		
		aaCheckBox.setToolTipText("Set Anti Aliasing On/Off");
		aaCheckBox.setSelected(true);
		aaCheckBox.setText("On/Off");
		aaCheckBox.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				aaAction(evt);
			}
		}); 
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		aaPanel.add(aaCheckBox, gridBagConstraints);
		
		aaPlotsCombo.setModel(
			new javax.swing.DefaultComboBoxModel(new String[] { "1", "2", "3", "4", "5", "10" }));
		aaPlotsCombo.setToolTipText("Select number of pixel plots");
		aaPlotsCombo.setSelectedIndex(2);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
		aaPanel.add(aaPlotsCombo, gridBagConstraints);

		aaPlotsLbl.setText("Plots pr pixel");
		aaPlotsLbl.setToolTipText("Number of plots pr pixel");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		aaPanel.add(aaPlotsLbl, gridBagConstraints);

		aaRaysCombo.setModel(
			new javax.swing.DefaultComboBoxModel(new String[] { "1", "5", "10", "50", "100", "1000" }));
		aaRaysCombo.setToolTipText("Select pixel rays pr plot");
		aaRaysCombo.setSelectedIndex(2);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.gridheight = java.awt.GridBagConstraints.RELATIVE;
		aaPanel.add(aaRaysCombo, gridBagConstraints);

		aaRaysLbl.setText("Rays pr plot");
		aaRaysLbl.setToolTipText("Rays pr plot");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1; 
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		aaPanel.add(aaRaysLbl, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 15);
		jPanel1.add(aaPanel, gridBagConstraints);
		
		pMapPanel.setLayout(new java.awt.GridBagLayout());
		pMapPanel.setBorder(new javax.swing.border.TitledBorder("Photon Mapping"));
		pMapPanel.setToolTipText("Photon Mapping Options");
		
		pmapCheckBox.setToolTipText("Set Photon Mapping On/Off");
		pmapCheckBox.setSelected(true);
		pmapCheckBox.setText("On/Off");
		pmapCheckBox.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				pMapAction(evt);
			}
		});
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		pMapPanel.add(pmapCheckBox, gridBagConstraints);
		
		radianceEstCombo.setModel(
			new javax.swing.DefaultComboBoxModel(
				new String[] { "10", "20", "30", "40", "50", "60", "70", "80", "90", "100", "250", "500", "1000" }));
		radianceEstCombo.setToolTipText("Select number of photons in radiance estimate");
		radianceEstCombo.setSelectedIndex(2);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		pMapPanel.add(radianceEstCombo, gridBagConstraints);
		
		photonsCombo.setModel(
			new javax.swing.DefaultComboBoxModel(
				new String[] { "1000", "10000", "50000", "100000", "200000", "500000", "1000000" }));
		photonsCombo.setToolTipText("Select number of photons");
		photonsCombo.setSelectedIndex(3);
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
		pMapPanel.add(photonsCombo, gridBagConstraints);
		
		radianceEstLbl.setText("Radiance est.");
		radianceEstLbl.setToolTipText("Number of Photons used in the Radiance estimate");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		pMapPanel.add(radianceEstLbl, gridBagConstraints);

		photonsLbl.setText("Photons");
		photonsLbl.setToolTipText("Total number of Photons");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		pMapPanel.add(photonsLbl, gridBagConstraints);

		distLbl.setText("Radiance search distance");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.insets = new java.awt.Insets(5, 0, 0, 0);
		pMapPanel.add(distLbl, gridBagConstraints);

		distSizeLbl.setToolTipText("null");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 3;
		pMapPanel.add(distSizeLbl, gridBagConstraints);

		distanceSlider.setMinorTickSpacing(1);
		distanceSlider.setMinimum(0);
		distanceSlider.setMajorTickSpacing(10);
		distanceSlider.setSnapToTicks(true);
		distanceSlider.setToolTipText("Set width of output image");
		distanceSlider.setMaximum(500);
		distanceSlider.setValue(10);
		distanceSlider.addMouseListener(new java.awt.event.MouseAdapter()
		{
			public void mouseClicked(java.awt.event.MouseEvent evt)
			{
				distanceSliderAction(evt);
			}
		});
		distanceSlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
		{
			public void mouseDragged(java.awt.event.MouseEvent evt)
			{
				distanceSliderAction(evt);
			}
		});
		
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 4;
		gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		pMapPanel.add(distanceSlider, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 15);
		jPanel1.add(pMapPanel, gridBagConstraints);

		outputPanel.setLayout(new java.awt.GridBagLayout());
		outputPanel.setBorder(new javax.swing.border.TitledBorder("Output Resolution"));
		outputPanel.setToolTipText("Adjust the output resolution");

		widthLbl.setText("Width");
		outputPanel.add(widthLbl, new java.awt.GridBagConstraints());

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 0;
		outputPanel.add(widthSizeLbl, gridBagConstraints);

		heightLbl.setText("Height");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		outputPanel.add(heightLbl, gridBagConstraints);
		
		heightSizeLbl.setToolTipText("null");
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 1;
		gridBagConstraints.gridy = 2;
		outputPanel.add(heightSizeLbl, gridBagConstraints);
		
		widthSlider.setMinorTickSpacing(64);
		widthSlider.setMinimum(128);
		widthSlider.setMajorTickSpacing(128);
		widthSlider.setSnapToTicks(true);
		widthSlider.setToolTipText("Set width of output image");
		widthSlider.setMaximum(1920);
		widthSlider.setValue(320);
		widthSlider.addMouseListener(new java.awt.event.MouseAdapter()
		{
			public void mouseClicked(java.awt.event.MouseEvent evt)
			{
				widthSliderAction(evt);
			}
		});
		widthSlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
		{
			public void mouseDragged(java.awt.event.MouseEvent evt)
			{
				widthSliderAction(evt);
			}
		});
	
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 1;
		gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		outputPanel.add(widthSlider, gridBagConstraints);
		
		heightSlider.setMinorTickSpacing(64);
		heightSlider.setMinimum(128);
		heightSlider.setMajorTickSpacing(128);
		heightSlider.setSnapToTicks(true);
		heightSlider.setValueIsAdjusting(true);
		heightSlider.setToolTipText("Set height of output image");
		heightSlider.setMaximum(1920);
		heightSlider.setValue(256);
		heightSlider.addMouseListener(new java.awt.event.MouseAdapter()
		{
			public void mouseClicked(java.awt.event.MouseEvent evt)
			{
				heightSliderAction(evt);
			}
		});
		heightSlider.addMouseMotionListener(new java.awt.event.MouseMotionAdapter()
		{
			public void mouseDragged(java.awt.event.MouseEvent evt)
			{
				heightSliderAction(evt);
			}
		});

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		outputPanel.add(heightSlider, gridBagConstraints);
		
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 2;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 15);
		jPanel1.add(outputPanel, gridBagConstraints);

		scenePanel.setLayout(new java.awt.GridBagLayout());
		scenePanel.setBorder(new javax.swing.border.TitledBorder("Scene"));
		scenePanel.setToolTipText("Scene File Selection");

		sceneFileField.setToolTipText("Currently loaded scene file location");
		sceneFileField.setPreferredSize(new java.awt.Dimension(100, 19));

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridwidth = java.awt.GridBagConstraints.RELATIVE;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 5);
		scenePanel.add(sceneFileField, gridBagConstraints);

		sceneChooserButton.setToolTipText("Select a scene file");
		sceneChooserButton.setText("Choose");
		sceneChooserButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				chooseSceneAction(evt);
			}
		});
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
		scenePanel.add(sceneChooserButton, gridBagConstraints);

		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 3;
		gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
		gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 15);
		jPanel1.add(scenePanel, gridBagConstraints);

		renderButton.setToolTipText("Render!");
		renderButton.setMnemonic('R');
		renderButton.setText("Render");
		renderButton.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(java.awt.event.ActionEvent evt)
			{
				renderAction(evt);
			}
		});
		gridBagConstraints = new java.awt.GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 4;
		gridBagConstraints.insets = new java.awt.Insets(5, 15, 5, 15);
		gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
		jPanel1.add(renderButton, gridBagConstraints);

		getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

		widthSliderAction(null);
		heightSliderAction(null);
		distanceSliderAction(null);

		pack();
	}
	private void heightSliderAction(java.awt.event.MouseEvent evt)
	{
		// Add your handling code here:
		heightSizeLbl.setText(String.valueOf(heightSlider.getValue()));
	}
	private void widthSliderAction(java.awt.event.MouseEvent evt)
	{
		// Add your handling code here:
		widthSizeLbl.setText(String.valueOf(widthSlider.getValue()));
	}
	private void distanceSliderAction(java.awt.event.MouseEvent evt)
	{
		// Add your handling code here:
		distSizeLbl.setText(String.valueOf(((float) distanceSlider.getValue()) / 10f));
	}
	private void chooseSceneAction(java.awt.event.ActionEvent evt)
	{
		// Add your handling code here:
		JFileChooser chooser = new JFileChooser();
		FileFilter filter = new FileFilter()
		{
			/**
			 * @see FileFilter#accept(File)
			 */
			public boolean accept(File file)
			{
				if (file.isDirectory())
					return true;

				if (file.getName().toLowerCase().endsWith("scd"))
				{
					return true;
				}
				else
					return false;
			}

			/**
			 * @see FileFilter#getDescription()
			 */
			public String getDescription()
			{
				return "*.scd";
			}

		};
		chooser.addChoosableFileFilter(filter);
		chooser.setMultiSelectionEnabled(false);

		if (chooser.showOpenDialog(this) != JFileChooser.APPROVE_OPTION)
		{
			return;
		}
		sceneFile = chooser.getSelectedFile();
		if (sceneFile != null)
			sceneFileField.setText(sceneFile.getPath());

	}
	private void renderAction(java.awt.event.ActionEvent evt)
	{
		// Add your handling code here:
		sceneFile = new File(sceneFileField.getText());
		if (sceneFile != null && sceneFile.exists())
		{
			System.err.println("renbder");
			render();
		}
		else if (sceneFile == null)
		{
			JOptionPane.showMessageDialog(
				null,
				"No .scd file selected",
				"Error",
				JOptionPane.ERROR_MESSAGE);
			//If there is an array of option buttons:
		}
		else
		{
			JOptionPane.showMessageDialog(null, "Error", "File does not exist", JOptionPane.ERROR_MESSAGE);
		}
	}
	public void render()
	{
		Options options = new Options();
		options.put("width", widthSizeLbl.getText());
		options.put("height", heightSizeLbl.getText());
		String plots = "1";
		String rays = "1";
		if (aaCheckBox.isSelected())
		{
			plots = (String) aaPlotsCombo.getSelectedItem();
			rays = (String) aaRaysCombo.getSelectedItem();
		}
		options.put("plots", plots);
		options.put("rays", rays);
		if (pmapCheckBox.isSelected())
		{
			options.put("photonmap", (String) photonsCombo.getSelectedItem());
			options.put("radiance", (String) radianceEstCombo.getSelectedItem());
			options.put("distance", distSizeLbl.getText());
		}
		options.put("threads", "1");
		Scene scene;
		try 
		{
			scene = new SceneLoader(new java.io.File(sceneFileField.getText()), options).buildScene();
			//= new TextureSceneLoader().getScene(null);

			DefaultOutput output = new DefaultOutput(options);

			dk.ruc.vbr.Raytracer tracer = new dk.ruc.vbr.Raytracer(scene, output, options);

			RaytracerDisplay display = new RaytracerDisplay(tracer);
			//tracer.render();
			//Thread thread = new Thread(display);
			display.start();

		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

	}
	private void aaAction(java.awt.event.ActionEvent evt)
	{
		// Add your handling code here:
		boolean is = aaCheckBox.isSelected();
		aaRaysLbl.setEnabled(is);
		aaPlotsCombo.setEnabled(is);
		aaRaysCombo.setEnabled(is);
		aaPlotsLbl.setEnabled(is);
	}
	private void pMapAction(java.awt.event.ActionEvent evt)
	{
		// Add your handling code here:
		boolean is = pmapCheckBox.isSelected();
		photonsCombo.setEnabled(is);
		radianceEstLbl.setEnabled(is);
		photonsLbl.setEnabled(is);
		radianceEstCombo.setEnabled(is);
		distanceSlider.setEnabled(is);
		distLbl.setEnabled(is);
		distSizeLbl.setEnabled(is);

	} /** Exit the Application */
	private void exitForm(java.awt.event.WindowEvent evt)
	{
		System.exit(0);
	} /**
				 * @param args the command line arguments
				 */
	public static void main(String args[])
	{
		try {
			PrintStream err = new PrintStream (new FileOutputStream
					      ("Redirect.err"));
			System.setErr(err);
		} catch(FileNotFoundException e) {
		}
		new RaytracerGUI(args).show();
	}

}